source edit-this
source $descOrSave
set kewliovers "5"
lappend dtopic "kewli0.tcl v$kewliovers by k-no <keith@cs.oswego.edu>"
#################
# HELP commands #
#################

#=============#
# ANYONE help #
#=============#

bind pub - "$x_\help" pub_do_ahelp
bind pub - "$x_ help" pub_do_ahelp
bind pub o "$o_\help" pub_do_ahelp
bind pub o "$o_ help" pub_do_ahelp
bind pub m "$m_\help" pub_do_ahelp
bind pub m "$m_ help" pub_do_ahelp
bind pub n "$n_\help" pub_do_ahelp
bind pub n "$n_ help" pub_do_ahelp
proc pub_do_ahelp {nick uhost handle channel vars} {
    global ret
    global x_ botnick
    set cmd [lindex $vars 0]
    if {$cmd == "notes"} {
        puthelp "NOTICE $nick :%%% Help for \"$x_\Notes\" %%%"
        puthelp "NOTICE $nick :USAGE: $x_\Notes <read|index|erase>"
        puthelp "NOTICE $nick :   Just like the '/msg $botnick NOTES' command."
        return $ret
    } elseif {$cmd == "chanmsg"} {
        puthelp "NOTICE $nick :%%% Help for \"$x_\chanmsg\" %%%"
        puthelp "NOTICE $nick :USAGE: $x_\chanmsg <flags> <msg>"
        puthelp "NOTICE $nick :   I will /notice all the people on the channel with the flags <flags> the message <msg>."
        return $ret
    } elseif {$cmd == "chat"} {
        if {[matchattr $nick x] || [matchattr $nick p]} {
            puthelp "NOTICE $nick :%%% Help for \"$x_\chat\" %%%"
            puthelp "NOTICE $nick :USAGE: $x_\chat"
            puthelp "NOTICE $nick :   I will DCC Chat you."
            return $ret
        }
    } elseif {$cmd == "seen"} {
        puthelp "NOTICE $nick :%%% Help for \"$x_\seen\" %%%"
        puthelp "NOTICE $nick :USAGE: $x_\seen <nick>"
        puthelp "NOTICE $nick :   I will tell you the last time <nick> was on $channel."
        return $ret
    } elseif {$cmd == "chattrs"} {
        puthelp "NOTICE $nick :%%% Help for \"$x_\chattrs\" %%%"
        puthelp "NOTICE $nick :USAGE: $x_\chattrs"
        puthelp "NOTICE $nick :   I will tell you what attributes you have listed on my userfile."
        return $ret
    } elseif {$cmd == "chanlist"} {
        puthelp "NOTICE $nick :%%% Help for \"$x_\chanlist\" %%%"
        puthelp "NOTICE $nick :USAGE: $x_\chanlist"
        puthelp "NOTICE $nick :   I will tell you who's on the channel."
        puthelp "NOTICE $nick :       $x_\chanlist \[flags\]"
        puthelp "NOTICE $nick :   I will tell you who on the channel has the flags (\[flags\]) (i.e., +m)."
        return $ret
    } elseif {$cmd == "note"} {
        puthelp "NOTICE $nick :%%% Help for \"$x_\Note\" %%%"
        puthelp "NOTICE $nick :USAGE: $x_\Note <nick> <message>"
        puthelp "NOTICE $nick :   I will send the BotNote <message> from you to <nick>."
        return $ret
    } elseif {$cmd == "time"} {
        puthelp "NOTICE $nick :%%% Help for \"$x_\Time\" %%%"
        puthelp "NOTICE $nick :USAGE: $x_\Time"
        puthelp "NOTICE $nick :   I will tell you the exact time and date."
        return $ret
    } elseif {$cmd == "hosts"} {
        puthelp "NOTICE $nick :%%% Help for \"$x_\hosts\" %%%"
        puthelp "NOTICE $nick :USAGE: $x_\hosts"
        puthelp "NOTICE $nick :   I will tell you your current hostmasks on my userlist."
        return $ret
    } elseif {$cmd == "info"} {
        puthelp "NOTICE $nick :%%% Help for \"$x_\info\" %%%"
        puthelp "NOTICE $nick :USAGE: $x_\info \[new info line\]"
        puthelp "NOTICE $nick :   The bot will change your info line to \[new info line\]."
        puthelp "NOTICE $nick :       $x_\info"
        puthelp "NOTICE $nick :   The bot will tell you your current info line."
        return $ret
    }
    puthelp "NOTICE $nick : %%%%% Help for regular people :) %%%%%"
    puthelp "NOTICE $nick : seen           chattrs"
    puthelp "NOTICE $nick : chanlist       note"
    puthelp "NOTICE $nick : time           hosts"
    puthelp "NOTICE $nick : info           notes"
    puthelp "NOTICE $nick : chanmsg        chat"
    puthelp "NOTICE $nick :All commands begin with a \"$x_\"."
    puthelp "NOTICE $nick :You can get help on individual commands: \"$x_\help <command>\""
    puthelp "NOTICE $nick :Remember all commands are done in the channel window."
    return $ret
}

#=========#
# OP help #
#=========#

bind pub o "$o_\help" pub_do_ohelp
bind pub o "$o_ help" pub_do_ohelp
bind pub m "$m_\help" pub_do_ahelp
bind pub m "$m_ help" pub_do_ahelp
bind pub n "$n_\help" pub_do_ahelp
bind pub n "$n_ help" pub_do_ahelp
proc pub_do_ohelp {nick uhost handle channel vars} {
    global ret
    global o_ x_
    set cmd [lindex $vars 0]
    if {$cmd == "tkb"} {
        puthelp "NOTICE $nick :%%% Help for \"$o_\Tkb\" %%%"
        puthelp "NOTICE $nick :USAGE: $o_\Tkb <nick> <time in minutes how long the ban will last> \[reason\]"
        puthelp "NOTICE $nick :   I will kick and ban <nick> for <time in minutes ...>."
        return $ret
    } elseif {$cmd == "kix" || $cmd == "sig"} {
        puthelp "NOTICE $nick :%%% Help for \"$o_\kix\" and \"$o_\Sig\" %%%"
        puthelp "NOTICE $nick :USAGE: $o_\kix <nickname>"
        global botnick
        puthelp "NOTICE $nick :   I will use your signature kick (see next notice) and kick someone, like *** <nickname> was kicked from $channel by $botnick (<signature kick>)."
        puthelp "NOTICE $nick :USAGE: $o_\Sig <set|erase|test> \[text\]"
        puthelp "NOTICE $nick :   I will do what you say to your signature kick."
        return $ret
    } elseif {$cmd == "kewli0"} {
        puthelp "NOTICE $nick :%%% Help for \"$o_\kewli0\" %%%"
        puthelp "NOTICE $nick :USAGE: $o_\kewli0 \[nickname\]"
        puthelp "NOTICE $nick :   I will send kewli0.tcl to you or \[nickname\]."
        return $ret
    } elseif {$cmd == "onchan"} {
        puthelp "NOTICE $nick :%%% Help for \"$o_\onchan\" %%%"
        puthelp "NOTICE $nick :USAGE: $o_\onchan <handle>"
        puthelp "NOTICE $nick :   I will tell you if <handle> (a bot handle, not nickname) is on $channel."
        return $ret
    }
    
    if {$cmd == "tkban"} {
        puthelp "NOTICE $nick :%%% Help for \"$o_\Tkban\" %%%"
        puthelp "NOTICE $nick :USAGE: $o_\Tkban <nick> <time in minutes how long the ban will last> \[reason\]"
        puthelp "NOTICE $nick :   I will kick and ban <nick> (in a kewl way) for <time in minutes ...>."
        return $ret
    } elseif {$cmd == "whois"} {
        puthelp "NOTICE $nick :%%% Help for \"$o_\Whois\" %%%"
        puthelp "NOTICE $nick :USAGE: $o_\Whois <handle>"
        puthelp "NOTICE $nick :   This is exactly like \".whois\" in DCC Chat with the bot. Cool, huh? :)"
        return $ret
    } elseif {$cmd == "clean"} {
        puthelp "NOTICE $nick :%%% Help for \"$o_\clean\" %%%"
        puthelp "NOTICE $nick :USAGE: $o_\clean"
        puthelp "NOTICE $nick :   I will kick all the -o's on the bot and op all the +o's on the channel."
    } elseif {$cmd == "kban"} {
        puthelp "NOTICE $nick :%%% Help for \"$o_\kban\" %%%"
        puthelp "NOTICE $nick :USAGE: $o_\kban <nick> \[reason\]"
        puthelp "NOTICE $nick :   I will add a permanent ban on <nick>'s hostmask.. but with a fun twist =]"
        return $ret
    } elseif {$cmd == "flip"} {
        puthelp "NOTICE $nick :%%% Help for \"$o_\Flip\" %%%"
        puthelp "NOTICE $nick :USAGE: $o_\Flip <text>"
        puthelp "NOTICE $nick :   I will totally reverse the order of the \*letters\* in <text>."
        return $ret
    } elseif {$cmd == "ctcp"} {
        puthelp "NOTICE $nick :%%% Help for \"$o_\ctcp\" %%%"
        puthelp "NOTICE $nick :USAGE: $o_\ctcp <nick> <ctcp command>"
        puthelp "NOTICE $nick :   I will /ctcp <nick> <ctcp command>."
        return $ret
    } 
    if {$cmd == "say"} {
        puthelp "NOTICE $nick :%%% Help for \"$o_\say\" %%%"
        puthelp "NOTICE $nick :USAGE: $o_\say <text>"
        puthelp "NOTICE $nick :   I will say <text> in the $channel window."
        return $ret
    } elseif {$cmd == "op"} {
        puthelp "NOTICE $nick :%%% Help for \"$o_\op\" %%%"
        puthelp "NOTICE $nick :USAGE: $o_\op"
        puthelp "NOTICE $nick :   I will op you."
        puthelp "NOTICE $nick :       $o_\op <nick>"
        puthelp "NOTICE $nick :   I will op <nick>."
        return $ret
    } elseif {$cmd == "deop"} {
        puthelp "NOTICE $nick :%%% Help for \"$o_\deop\" %%%"
        puthelp "NOTICE $nick :USAGE: $o_\deop"
        puthelp "NOTICE $nick :   I will deop you."
        puthelp "NOTICE $nick :       $o_\deop <nick>"
        puthelp "NOTICE $nick :   I will deop <nick>"
        return $ret
    } elseif {$cmd == "devoice"} {
        puthelp "NOTICE $nick :%%% Help for \"$o_\devoice\" %%%"
        puthelp "NOTICE $nick :USAGE: $o_\devoice"
        puthelp "NOTICE $nick :   I will devoice (-v) you."
        puthelp "NOTICE $nick :       $o_\devoice <nick>"
        puthelp "NOTICE $nick :   I will devoice (-v) <nick>."
        return $ret
    } elseif {$cmd == "msg"} {
        puthelp "NOTICE $nick :%%% Help for \"$o_\msg\" %%%"
        puthelp "NOTICE $nick :USAGE: $o_\msg <nick> <message>"
        puthelp "NOTICE $nick :   I will /msg <nick> the message <message>."
        return $ret
    } elseif {$cmd == "topic"} {
        puthelp "NOTICE $nick :%%% Help for \"$o_\Topic\" %%%"
        puthelp "NOTICE $nick :USAGE: $o_\Topic <topic>"
        puthelp "NOTICE $nick :   I will change the channel topic to <topic>"
        return $ret
    } elseif {$cmd == "mode"} {
        puthelp "NOTICE $nick :%%% Help for \"$o_\mode\" %%%"
        puthelp "NOTICE $nick :USAGE: $o_\mode <channel mode>"
        puthelp "NOTICE $nick :   I will change the channel mode to <channel mode>."
        return $ret
    } elseif {$cmd == "notice"} {
        puthelp "NOTICE $nick :%%% Help for \"$o_\Notice\" %%%"
        puthelp "NOTICE $nick :USAGE: $o_\Notice <nick> <message>"
        puthelp "NOTICE $nick :   I will /notice <nick> the message <message>."
        return $ret
    } elseif {$cmd == "act"} {
        puthelp "NOTICE $nick :%%% Help for \"$o_\Act\" %%%"
        puthelp "NOTICE $nick :USAGE: $o_\Act <action>"
        puthelp "NOTICE $nick :   I will perform an action, like /me <action>."
        return $ret
    } elseif {$cmd == "kick"} {
        puthelp "NOTICE $nick :%%% Help for \"$o_\kick\" %%%"
        puthelp "NOTICE $nick :USAGE: $o_\kick <nick>"
        puthelp "NOTICE $nick :   I will kick <nick> from $channel with the default reason."
        puthelp "NOTICE $nick :       $o_\kick <nick> <reason>"
        puthelp "NOTICE $nick :   I will kick <nick> from $channel with the reason <reason>."
        return $ret
    } elseif {$cmd == "kb"} {
        puthelp "NOTICE $nick :%%% Help for \"$o_\kb\" %%%"
        puthelp "NOTICE $nick :USAGE: $o_\kb <nick>"
        puthelp "NOTICE $nick :   I will kick and ban <nick> with the default reason."
        puthelp "NOTICE $nick :       $o_\kb <nick> <reason>"
        puthelp "NOTICE $nick :   I will kick and ban <nick> with the reason <reason>."
        return $ret
    } elseif {$cmd == "ban"} {
        puthelp "NOTICE $nick :%%% Help for \"$o_\Ban\" %%%"
        puthelp "NOTICE $nick :USAGE: $o_\Ban <nick>"
        puthelp "NOTICE $nick :   I will ban <nick> (not his hostmask!) from $channel with the default reason."
        puthelp "NOTICE $nick :       $o_\Bban <nick> <reason>"
        puthelp "NOTICE $nick :   I will ban <nick> (not his hostmask!) from $channel with the reason <reason>."
        return $ret
    } elseif {$cmd == "unban"} {
        puthelp "NOTICE $nick :%%% Help for \"$o_\unban\" %%%"
        puthelp "NOTICE $nick :USAGE: $o_\unban <nick/host>"
        puthelp "NOTICE $nick :   I will unban <nick/host>"
        return $ret
    } elseif {$cmd == "voice"} {
        puthelp "NOTICE $nick :%%% Help for \"$o_\Voice\" %%%"
        puthelp "NOTICE $nick :USAGE: $o_\Voice"
        puthelp "NOTICE $nick :   I will voice you on $channel."
        puthelp "NOTICE $nick :       $o_\Voice <nick>"
        puthelp "NOTICE $nick :   I will voice <nick> on $channel."
        return $ret
    } elseif {$cmd == "version"} {
        puthelp "NOTICE $nick :%%% Help for \"$o_\Version\" %%%"
        puthelp "NOTICE $nick :USAGE: $o_\Version"
        puthelp "NOTICE $nick :   I will tell you what version of Eggdrop I am running on."
        return $ret
    } elseif {$cmd == "ctcpr"} {
        puthelp "NOTICE $nick :%%% Help for \"$o_\ctcpr\" %%%"
        puthelp "NOTICE $nick :USAGE: $o_\ctcpr <nick> <command> <reply>"
        puthelp "NOTICE $nick :   I will send <nick> a fake CTCP reply to <command> that will say <reply>, i.e., \"[$botnick PING reply]: 30 bazillion light years\"."
        return $ret
    } elseif {$cmd == "dcc"} {
        puthelp "NOTICE $nick :%%% Help for \"$o_\dcc\" %%%"
        puthelp "NOTICE $nick :USAGE: $o_\dcc <dcc command>"
        puthelp "NOTICE $nick :   I will pretend you are DCC chatting me, and do <dcc command>."
        return $ret
    } elseif {$cmd == "dcclist"} {
        puthelp "NOTICE $nick :%%% Help for \"$o_\dcclist\" %%%"
        puthelp "NOTICE $nick :USAGE: $o_\dcclist"
        puthelp "NOTICE $nick :   I will tell you who is currently DCC chatting me."
        return $ret
    } elseif {$cmd == "getidle"} {
        puthelp "NOTICE $nick :%%% Help for \"$o_\getidle\" %%%"
        puthelp "NOTICE $nick :USAGE: $o_\getidle <nick>"
        puthelp "NOTICE $nick :   I will tell you how long <nick> has been idle on $channel."
        return $ret
    } elseif {$cmd == "channels"} {
        puthelp "NOTICE $nick :%%% Help for \"$o_\channels\" %%%"
        puthelp "NOTICE $nick :USAGE: $o_\channels"
        puthelp "NOTICE $nick :   I will tell you what channels I am currently monitoring."
        return $ret
    } elseif {$cmd == "bots"} {
        puthelp "NOTICE $nick :%%% Help for \"$o_\Bots\" %%%"
        puthelp "NOTICE $nick :USAGE: $o_\Bots"
        puthelp "NOTICE $nick :   I will tell you which bots are connected to my PartyLine."
        return $ret
    } elseif {$cmd == "invite"} {
        puthelp "NOTICE $nick :%%% Help for \"$o_\invite\" %%%"
        puthelp "NOTICE $nick :USAGE: $o_\invite <nick>"
        puthelp "NOTICE $nick :   I will /invite <nick> to $channel."
        return $ret
    } elseif {$cmd == "ping"} {
        puthelp "NOTICE $nick :%%% Help for \"$o_\ping\" %%%"
        puthelp "NOTICE $nick :USAGE: $o_\ping"
        puthelp "NOTICE $nick :   I will reply to \"$o_\ping\" with \"PONG!\" in the channel window."
        return $ret
    } elseif {$cmd == "rkick"} {
        puthelp "NOTICE $nick :%%% Help for \"$o_\Rkick\" %%%"
        puthelp "NOTICE $nick :USAGE: $o_\Rkick"
        puthelp "NOTICE $nick :   I will kick a random non-op off the channel >=\]"
        return $ret
    } elseif {$cmd == "topics"} {
        puthelp "NOTICE $nick :%%% Help for \"$o_\Topics\" %%%"
        puthelp "NOTICE $nick :USAGE: $o_\Topics"
        puthelp "NOTICE $nick :   I will show you all the default topics."
        return $ret
    } elseif {$cmd == "addtopic"} {
        puthelp "NOTICE $nick :%%% Help for \"$o_\Addtopic\" %%%"
        puthelp "NOTICE $nick :USAGE: $o_\Addtopic <topic>"
        puthelp "NOTICE $nick :   I will add a new topic to the default topic list."
        return $ret
    } elseif {$cmd == "deltopic"} {
        puthelp "NOTICE $nick :%%% Help for \"$o_\deltopic\" %%%"
        puthelp "NOTICE $nick :USAGE: $o_\deltopic <topic|number>"
        puthelp "NOTICE $nick :   I will delete a topic from the default topics list."
        return $ret
    } else {
	puthelp "NOTICE $nick :"
	puthelp "NOTICE $nick :        %%% OP help %%%"
	puthelp "NOTICE $nick :        % Regular help %"
	puthelp "NOTICE $nick :(Type $x_\commandName to activate"
	puthelp "NOTICE $nick : the reg. commands.)"
	puthelp "NOTICE $nick : seen     chattrs  chanlist   note"
	puthelp "NOTICE $nick : time     hosts    info       notes"
	puthelp "NOTICE $nick : chanmsg  chat"
	puthelp "NOTICE $nick :        %    Op help   %"
	puthelp "NOTICE $nick :op        deop     devoice    msg"
	puthelp "NOTICE $nick :topic     mode     notice     me"
	puthelp "NOTICE $nick :kick      kb       Ban        voice"
	puthelp "NOTICE $nick :version   dcclist  getidle    channels"
	puthelp "NOTICE $nick :bots      invite   ping       rkick"
	puthelp "NOTICE $nick :Voice     unban    kban       tkb"
	puthelp "NOTICE $nick :tkban     whois    clean      kix"
	puthelp "NOTICE $nick :sig       kewli0   onchan     topics"
	puthelp "NOTICE $nick :deltopic  addtopic "
	puthelp "NOTICE $nick :All commands begin with a \"$o_\"."
	puthelp "NOTICE $nick :Other help files: $x_\help - for regular commands."
	puthelp "NOTICE $nick :You can get help on individual commands: \"$o_\help <command>\"."
	return $ret
    }
}

#=============#
# MASTER help #
#=============#

bind pub m "$m_\help" pub_do_mhelp
bind pub m "$m_ help" pub_do_mhelp
bind pub n "$n_\help" pub_do_ahelp
bind pub n "$n_ help" pub_do_ahelp
proc pub_do_mhelp {nick uhost handle channel vars} {
    global ret m_ o_ x_
    set cmd [string tolower [lindex $vars 0]]
    if {$cmd == "status"} {
        puthelp "NOTICE $nick :%%% Help for \"$m_\status\" %%%"
        puthelp "NOTICE $nick :USAGE: $m_\status"
        puthelp "NOTICE $nick :   I will tell you the status of kewli0.tcl, i.e., logging on/off, etc."
        return $ret
    } elseif {$cmd == "jump"} {
        puthelp "NOTICE $nick :%%% Help for \"$m_\jump\" %%%"
        puthelp "NOTICE $nick :USAGE: $m_\jump <server>"
        puthelp "NOTICE $nick :   I will jump to <server> on port 6667."
        puthelp "NOTICE $nick :       $m_\jump <server> \[port\]"
        puthelp "NOTICE $nick :   I will jump to <server> on port \[port\]."
        return $ret
    } elseif {$cmd == "link"} {
        puthelp "NOTICE $nick :%%% Help for \"$m_\link\" %%%"
        puthelp "NOTICE $nick :USAGE: $m_\link <bot>"
        puthelp "NOTICE $nick :   I will link <bot> to my PartyLine."
        return $ret
    } elseif {$cmd == "unlink"} {
        puthelp "NOTICE $nick :%%% Help for \"$m_\unlink\" %%%"
        puthelp "NOTICE $nick :USAGE: $m_\unlink <bot>"
        puthelp "NOTICE $nick :   I will terminate the connection from my PartyLine to <bot>'s."
        return $ret
    } elseif {$cmd == "deluser"} {
        puthelp "NOTICE $nick :%%% Help for \"$m_\deluser\" %%%"
        puthelp "NOTICE $nick :USAGE: $m_\deluser <handle>"
        puthelp "NOTICE $nick :   I will remove <handle> from my user file."
        return $ret
    } elseif {$cmd == "save"} {
        puthelp "NOTICE $nick :%%% Help for \"$m_\save\" %%%"
        puthelp "NOTICE $nick :USAGE: $m_\save"
        puthelp "NOTICE $nick :   I will save my user file."
        return $ret
    } elseif {$cmd == "host"} {
        puthelp "NOTICE $nick :%%% Help for \"$m_\host\" %%%"
        puthelp "NOTICE $nick :USAGE: $m_\host <nick>"
        puthelp "NOTICE $nick :   I will tell you the current hostmasks registered on me for <nick>."
        return $ret
    } elseif {$cmd == "userlist"} {
        puthelp "NOTICE $nick :%%% Help for \"$m_\userlist\" %%%"
        puthelp "NOTICE $nick :USAGE: $m_\userlist"
        puthelp "NOTICE $nick :   I will tell you all of the people registered on me."
        puthelp "NOTICE $nick :       $m_\userlist [flags]"
        puthelp "NOTICE $nick :   I will tell you who is registered on ym userlist as having the flags [flags]."
        return $ret
    } elseif {$cmd == "users"} {
        puthelp "NOTICE $nick :%%% Help for \"$m_\users\" %%%"
        puthelp "NOTICE $nick :USAGE: $m_\users"
        puthelp "NOTICE $nick :   I will tell you how many users I have registered in my userfile."
        return $ret
    } elseif {$cmd == "set"} {
        puthelp "NOTICE $nick :%%% Help for \"$m_\set\" %%%"
        puthelp "NOTICE $nick :USAGE: $m_\set <attribute> <args>"
        puthelp "NOTICE $nick :   I will set <attribute> to <args>."
        return $ret
    } elseif {$cmd == "adduser"} {
        global rand_pass
        if {$rand_pass == 0} {set pass no} {set pass "a random"}
        puthelp "NOTICE $nick :%%% Help for \"$m_\Adduser\" %%%"
        puthelp "NOTICE $nick :USAGE: $m_\Adduser <nick>"
        puthelp "NOTICE $nick :   I will add <nick> to my userlist with flags +$fgs and $pass password."
        puthelp "NOTICE $nick :       $m_\Adduser <nick> \[flags\]"
        puthelp "NOTICE $nick :   I will add <nick> to my userlist with the flags \[flags\], and the flags +$fgs, and $pass password."
        return $ret
    } else {
	puthelp "NOTICE $nick :      %%% MASTER help %%%"
	puthelp "NOTICE $nick :        % Regular help %"
	puthelp "NOTICE $nick :(Type $x_\commandName to activate"
	puthelp "NOTICE $nick : the reg. commands.)"
	puthelp "NOTICE $nick : seen     chattrs  chanlist   note"
	puthelp "NOTICE $nick : time     hosts    info       notes"
	puthelp "NOTICE $nick : chanmsg  chat"
	puthelp "NOTICE $nick :        %    Op help   %"
	puthelp "NOTICE $nick :op        deop     devoice    msg"
	puthelp "NOTICE $nick :topic     mode     notice     me"
	puthelp "NOTICE $nick :kick      kb       Ban        voice"
	puthelp "NOTICE $nick :version   dcclist  getidle    channels"
	puthelp "NOTICE $nick :bots      invite   ping       rkick"
	puthelp "NOTICE $nick :Voice     unban    kban       tkb"
	puthelp "NOTICE $nick :tkban     whois    clean      kix"
	puthelp "NOTICE $nick :sig       kewli0   onchan     topics"
	puthelp "NOTICE $nick :deltopic  addtopic "
	puthelp "NOTICE $nick :        %  Master help %"
	puthelp "NOTICE $nick :link      unlink   deluser   set"
	puthelp "NOTICE $nick :save      host     userlist  users"
	puthelp "NOTICE $nick :Adduser   jump     "
	puthelp "NOTICE $nick :All commands begin with a \"$m_\"."
	puthelp "NOTICE $nick :You can get help on individual commands: \"$m_\help <command>\"."
	puthelp "NOTICE $nick :Other help files: $x_\help - for regular commands."
	puthelp "NOTICE $nick :                  $o_\help - for op commands."
	return $ret
    }
}

#============#
# OWNER help #
#============#

bind pub n "$n_\help" pub_do_nhelp
bind pub n "$n_ help" pub_do_nhelp
proc pub_do_nhelp {nick uhost handle channel vars} {
    global n_ m_ o_ x_ ret
    set cmd [lindex $vars 0]
    set v2 [lindex $vars 0]
    if {$cmd == "tcl"} {
        puthelp "NOTICE $nick :%%% Help for \"$n_\Tcl" %%%"
        puthelp "NOTICE $nick :USAGE: $n_\Tcl <tcl script/command>"
        puthelp "NOTICE $nick :   Useful if you need some quick Tcl help. I will execute the command you ask me to, and give you the results."
        return $ret
    } elseif {$cmd == "ksave"} {
        puthelp "NOTICE $nick :%%% Help for \"$n_\ksave\" %%%"
        puthelp "NOTICE $nick :USAGE: $n_\ksave"
        puthelp "NOTICE $nick :   I will save all the kewli0.tcl vars..."
        return $ret
    } elseif {$cmd == "chattr"} {
        puthelp "NOTICE $nick :%%% Help for \"$n_\chattr\" %%%"
        puthelp "NOTICE $nick :USAGE: $n_\chattr <nick> <flags>"
        puthelp "NOTICE $nick :   I will change <nick>'s attributes to <flags>."
        return $ret
    } elseif {$cmd == "die"} {
        puthelp "NOTICE $nick :%%% Help for \"$n_\die\" %%%"
        puthelp "NOTICE $nick :USAGE: $n_\die"
        puthelp "NOTICE $nick :   I will totally shut down (the equivalent of \".die\" in DCC chat."
        return $ret
    } else {
	puthelp "NOTICE $nick :%%%%% OWNER help %%%%%"
	puthelp "NOTICE $nick :        % Regular help %"
	puthelp "NOTICE $nick :(Type $x_\commandName to activate"
	puthelp "NOTICE $nick : the reg. commands.)"
	puthelp "NOTICE $nick : seen     chattrs  chanlist   note"
	puthelp "NOTICE $nick : time     hosts    info       notes"
	puthelp "NOTICE $nick : chanmsg  chat"
	puthelp "NOTICE $nick :        %    Op help   %"
	puthelp "NOTICE $nick :op        deop     devoice    msg"
	puthelp "NOTICE $nick :topic     mode     notice     me"
	puthelp "NOTICE $nick :kick      kb       Ban        voice"
	puthelp "NOTICE $nick :version   dcclist  getidle    channels"
	puthelp "NOTICE $nick :bots      invite   ping       rkick"
	puthelp "NOTICE $nick :Voice     unban    kban       tkb"
	puthelp "NOTICE $nick :tkban     whois    clean      kix"
	puthelp "NOTICE $nick :sig       kewli0   onchan     topics"
	puthelp "NOTICE $nick :deltopic  addtopic "
	puthelp "NOTICE $nick :        %  Master help %"
	puthelp "NOTICE $nick :(Type $m_\commandName to activate"
	puthelp "NOTICE $nick : the master commands.)"
	puthelp "NOTICE $nick :link      unlink  deluser   set"
	puthelp "NOTICE $nick :save      host    userlist  users"
	puthelp "NOTICE $nick :Adduser   jump"
	puthelp "NOTICE $nick :        %  Owner help  %"
	puthelp "NOTICE $nick :do        chattr  die       tcl"
	puthelp "NOTICE $nick :ksave"
	puthelp "NOTICE $nick :All commands begin with a \"$n_\"."
	puthelp "NOTICE $nick :You can get help on individual commands: \"$n_\help <command>\"."
	puthelp "NOTICE $nick :Other help files: $x_\help - for regular help."
	puthelp "NOTICE $nick :                  $o_\help - for op help."
	puthelp "NOTICE $nick :                  $m_\help - for master help."
	return $ret
    }
}

#-------------------#
# ANYBODY commands: #
#-------------------#

bind pub - "$x_\Notes" pub_do_notes
bind pub - "$x_ notes" pub_do_notes
proc pub_do_notes {nick uhost handle channel vars} {
    global notefile ret x_
    set what [lindex $vars 0]
    set what2 [lindex $vars 1]
    set notereq [open $notefile r]
    if {$what == "read"} {
        if {$what2 == "all" && $what2 == ""} {
            set notenr 0
        }
        set notenr $what2
        set count 0
        while ![eof $notereq] {
            set i [gets $notereq]
            if {[lindex $i 0] == $handle} {
                incr count
                if {$count == $notenr || !$count} {
                    set time [ctime [lindex $i 2]]
                    set time "[lrange $time 1 2] [string range [lindex $i 3] 0 3]"
                    puthelp "NOTICE $nick :$count. [lindex $i 1] ($time): [lrange $i 3 end]"
                }
            }
        }
    }
}

bind pub - "$x_\chanmsg" pub_do_channote
bind pub - "$x_ chanmsg" pub_do_channote
proc pub_do_channote {nick uhost handle channel vars} {
    global ret respons x_
    set flags [lindex $vars 0]
    set note [lrange $vars 1 end]
    if {$flags == "" || $note == ""} {
        puthelp "NOTICE $nick :USAGE: $x_\chanmsg <flag(s)> <note>"
        return $ret
    }
    if {[chanlist $channel $flags] == ""} {
        puthelp "NOTICE $nick :Nobody on $channel has the specified flags $flags"
        return $ret
    }
    foreach i [dcclist] {
        if {[matchattr [lindex $i 1] $flags]} {
            putdcc [lindex $i 0] "Note \[$nick\]: \[+$flags\] $note"
            return $ret
        }
    }
    foreach i [chanlist $channel $flags] {
        puthelp "NOTICE $i :Note: \[$nick\]: \[+$flags\] $note"
        return $ret
    }
    return $ret
}

bind pub - "$x_\id4" pub_do_id4
bind pub - "$x_ id4" pub_do_id4
proc pub_do_id4 {nick uhost handle channel vars} {
    global ret respons
    set num [rand 9]
    set v1 [lindex $vars 0]
    if {$num == "0"} {
        puthelp "PRIVMSG $channel :\"We gotta stop 'em! They're gonna kill us all...\""
        return $ret
    }
    if {$num == "1"} {
        puthelp "PRIVMSG $channel :\"Thas what I call a close encounter.\""
        return $ret
    }
    if {$num == "2"} {
        puthelp "PRIVMSG $channel :\"Today, we celebrate our Independence Day!\""
        return $ret
    }
    if {$num == "3"} {
        puthelp "PRIVMSG $channel :\"The question of whether or not we are alone in the universe has been answered.\""
        return $ret
    }
    if {$num == "4"} {
        puthelp "PRIVMSG $channel :\"I don't think they flew ninety billion light years to come down here an' start a fight.\""
        return $ret
    }
    if {$num == "5"} {
        puthelp "PRIVMSG $channel :\"Let's nuke the bastards.\""
        return $ret
    }
    if {$num == "6"} {
        puthelp "PRIVMSG $channel :\"No sir, I'm just a li'l anxious to get up there and whoop E.T.'s ass, thas all.\""
        return $ret
    }
    if {$num == "7"} {
        puthelp "PRIVMSG $channel :\"Time's up.\""
        return $ret
    }
    if {$num == "8"} {
        puthelp "PRIVMSG $channel :Good morning."
        puthelp "PRIVMSG $channel :In less than an hour, aircraft from here will join others from around the world, and you will be launching the largest arial battle in the history mankind."
        puthelp "PRIVMSG $channel :Mankind, eh. The word should have new meaning for all of us today. We can't be consumed by our petty differences anymore; we will be united in our common interest."
        puthelp "PRIVMSG $channel :Perhaps it's fate that today is the Fourth of July. And you will once again be fighting for our freedom. Not from tyranny, opression, or persecution, but from annhilation. We're fighting for out right to live, to exist."
        puthelp "PRIVMSG $channel :And should we win the day, the Fourth of July will no longer be known as an American holiday, but as the day when the world delcared, in one voice, \"We will not go quietly into the night. We will not vanish without a fight. We're going to live on, we're going to survive.\""
        puthelp "PRIVMSG $channel :Today we celebrate our Independence Day!"
    }
    if {$num == "9"} {
        puthelp "PRIVMSG $channel :\"Oh NO. You did NOT shoot that green shit at ME.\""
        return $ret
    }
    return $ret
}

bind join - *!*@*.gnn.com pub_do_gnn
proc pub_do_gnn {nick uhost handle channel} {
    global ret respons gnn_
    if {$gnn_ == "1" && ![matchattr $handle f]} {
        puthelp "NOTICE $channel :GNN lamah alert!!! --> $nick"
        return $ret
    }
    return $ret
}

bind join - *!*@*.msn.com pub_do_msn
proc pub_do_msn {nick uhost handle channel} {
    global msn_ ret
    if {$msn_ == "1" && ![matchattr $handle f]} {
        puthelp "NOTICE $channel :Microsoft lamah Microsoft lamah! Run! --> $nick"
        return $ret
    }
    return $ret
}

bind join - *!*@*.aol.com pub_do_aol
proc pub_do_aol {nick uhost handle channel} {
    global ret respons aol_
    if {$aol_ == "1" && ![matchattr $handle f]} {
        puthelp "NOTICE $channel :AOLamah alert! AOLamah alert! Flee the city!! --> $nick"
        return $ret
    }
    return $ret
}

bind join - *!*@*.compuserve.com pub_do_compu
proc pub_do_compu {nick uhost handle channel} {
    global ret respons compu_
    if {$compu_ == "1" && ![matchattr $handle f]} {
        puthelp "NOTICE $channel :CompuLamah alert! CompuLamah alert! --> $nick"
        return $ret
    }
    return $ret
}

bind join - *!*@*.prodigy.com pub_do_prodigy
proc pub_do_prodigy {nick uhost handle channel} {
    global ret respons prodigy_
    if {$prodigy_ == "1" && ![matchattr $handle f]} {
        puthelp "NOTICE $channel :Prodigy lamah alert! Prodigy lamah alert! --> $nick"
        return $ret
    }
    return $ret
}

bind join - *!*@*.netcom.com pub_do_netcom
proc pub_do_netcom {nick uhost handle channel} {
    global ret respons netcom_
    if {$netcom_ == "1" && ![matchattr $handle f]} {
        puthelp "NOTICE $channel :Netcom lamah alert! Evacuate the channel immediately! --> $nick"
        return $ret
    }
    return $ret
}

bind join - * pub_do_greet
proc pub_do_greet {nick uhost handle channel} {
    global ret respons greet greetmsg
    if {$greet == "1" && ![validuser $handle]} {
        regsub -all &nick $greetmsg $nick greetmsg2
        regsub -all &channel $greetmsg2 $channel greetmsg2
        puthelp "PRIVMSG $channel :$greetmsg2"
    }
    return $ret
}
# simple implementation of the 'seen' command for eggdrop
# by Robey, 19mar95
# v2  4may95
# v3 eden 29sep95 - won't show seen if tandem-bot is on channel to do it
# v4 cmwagner@gate.net 25jan96 - msg/dcc interface instead of public,
#                                tandem-nick removed, since it is now a
#                                private interface, instead of public
# v4.1 cmwagner@gate.net 26mar96 - modified for eggdrop1.0
# v4.2 cmwagner@gate.net 26mar96 - ok, actually works now, I think.  <grin>
# v4.3 floydman@netaxs.com 29mar96 - added public access to seen.
# v4.4 floydman@netaxs.com 7apr96 - Changed the format of the reply from
#                                    the bot...to give No. of years, days,
#                                    hours, and minutes since somebody was
#                                    last on.
# v4.5 pulse@indy.mvbms.com 8jun96 - Fucked with Floyd's syntax, replaced 
#                                     putchan with putserv privmsg.
#                       		      Should work more consistently. 

bind pub - "seen" pub_seen
bind pub - "$x_\seen" pub_seen
bind pub - "$x_ seen" pub_seen
proc pub_seen {nick uhost hand channel args} {
    global blah
    global botnick 
    set who [string trim [lindex $args 0] ?]
    if {[string compare [string tolower $botnick] [string tolower $who]] == 0} {
        set blah [rand 3]
        global blah
        if {$blah == 2} {
            set blah [rand 3]
            global blah
            puthelp "PRIVMSG $channel :Yeah, whenever I look in a mirror..."      
            return 1
        }
		if {$blah == 1} {
            global blah
            set blah [rand 3]
            puthelp "PRIVMSG $channel :You are really stupid, $nick..."
            return 1
        } else {
            set blah [rand 3]
            global blah
            puthelp "PRIVMSG $channel :Yeah, whenever I look in a mirror..."      
            return 1
        }
        return 1
    }
    if {[string compare [string tolower $nick] [string tolower $who]] == 0} {
        puthelp "PRIVMSG $channel :Trying to find yourself, eh?"
        return 1
    }
    foreach j [channels] {
        if {[onchansplit $who $j]} {
            puthelp "PRIVMSG $channel :$who was just here, but got netsplit"
            return 1
        }
        if {[onchan $who $j]} {
            puthelp "PRIVMSG $channel :$who is on the channel right now."
            return 1
        }
        foreach i [chanlist $j] {
            set hand [finduser $i![getchanhost $i $j]]
            if {($hand != "*") && ([string compare [string tolower $hand] [string tolower $who]] == 0)} {
                if {[onchansplit $i $j]} {
                    puthelp "PRIVMSG $channel :$i is $who, and was just here but got net-split"
                } {
                    if {[onchan $i $j]} {
                        puthelp "PRIVMSG $channel :$i is $who, and $i is on $j right now!"
                    }
                }
                return 1
            }
        }
    }
    if {[validuser $who]} {
        set lasttime [getlaston $who]
        if {$lasttime == 0} {
            puthelp "PRIVMSG $channel :$who has never been here."
            return 1
        }
        set totalyear [expr [unixtime] - $lasttime]
        if {$totalyear > 31536000} {
            set yearsfull [expr $totalyear/31536000]
            set years [expr int($yearsfull)]
            set yearssub [expr 31536000*$years]
            set totalday [expr $totalyear - $yearssub] 
        }
        if {$totalyear < 31536000} {
            set totalday $totalyear
            set years 0
        }
        if {$totalday > 86400} {
            set daysfull [expr $totalday/86400]
            set days [expr int($daysfull)]
            set dayssub [expr 86400*$days]
            set totalhour [expr $totalday - $dayssub] 
        }
        if {$totalday < 86400} {
            set totalhour $totalday
            set days 0
        }
        if {$totalhour > 3600} {
            set hoursfull [expr $totalhour/3600]
            set hours [expr int($hoursfull)]
            set hourssub [expr 3600*$hours]
            set totalmin [expr $totalhour - $hourssub] 
        }
        if {$totalhour < 3600} {
            set totalmin $totalhour
            set hours 0
        }
        if {$totalmin > 60} {
            set minsfull [expr $totalmin/60]
            set mins [expr int($minsfull)]
        }
        if {$totalmin < 60} {
            $blah = [rand 2]
            if {$blah == 1} {
                puthelp "PRIVMSG $channel :$who left the channel less then a minute ago."
                return 1
            }
            if {blah == 0} {
                puthelp "PRIVMSG $channel :You just missed $who. Just left a minute ago."
                return 1
            }
        }
        if {$years < 1} then {set yearstext ""} else {set yearstext "$years years, "}
        if {$days < 1} then {set daystext ""} else {set daystext "$days days, "}
        if {$hours < 1} then {set hourstext ""} else {set hourstext "$hours hours, "}
        puthelp "PRIVMSG $channel :$who was last here $yearstext$daystext$hourstext$mins minutes ago on [ctime [getlaston $who]]"
        return 1
    }
    puthelp "PRIVMSG $channel :I don't know [lindex $who 0]."
}

###### End of Robey's 'seen.tcl' ######

bind pub - "$x_\chattrs" pub_do_chattrs
bind pub - "$x_ chattrs" pub_do_chattrs
proc pub_do_chattrs {nick uhost handle channel vars} {global ret respons
global botnick
set chattrs [chattr $handle]
if {![validuser $handle]} {
    puthelp "NOTICE $nick :You're not a valid user!"
    puthelp "NOTICE $nick :If you are already a user, but on a different account,"
    puthelp "NOTICE $nick :try /msg $botnick ident <your pass> <your handle>"
    puthelp "NOTICE $nick :Or, if you aren't on the bot, /msg $botnick <bind word>"
    puthelp "NOTICE $nick :to get added to me."
    return $ret
}
puthelp "NOTICE $nick :Your current attributes are +$chattrs on $botnick"
return $ret
}

bind pub - "$x_\chanlist" pub_do_chanlist
bind pub - "$x_ chanlist" pub_do_chanlist
proc pub_do_chanlist {nick uhost handle channel vars} {global ret respons
set flags [lindex $vars 0]
if {$flags == ""} {
    puthelp "NOTICE $nick :Current users on $channel: [chanlist $channel]"
    return $ret
}
if {[chanlist $channel $flags] == ""} {
    puthelp "NOTICE $nick :There are no $flags people on $channel"
    return $ret
}
puthelp "NOTICE $nick :Current $flags users on $channel: [chanlist $channel $flags]"
return $ret
}

bind pub - "$x_\Note" pub_do_note
bind pub - "$x_ Note" pub_do_note
proc pub_do_note {nick uhost handle channel vars} {global ret respons
global botnick
set who [lindex $vars 0]
set what [lrange $vars 1 end]
if {![validuser $handle]} {
    puthelp "NOTICE $nick :You are not a valid user!"
    puthelp "NOTICE $nick :If you are already a user, but on a different account,"
    puthelp "NOTICE $nick :try /msg $botnick ident <your pass> <your handle>"
    puthelp "NOTICE $nick :Or, if you aren't on the bot, /msg $botnick hello"
    puthelp "NOTICE $nick :to get added to me."
    return $ret
}
if {![validuser $who]} {
    puthelp "NOTICE $nick :$who isn't a valid user!"
    return $ret
}
sendnote $handle $who $what
puthelp "NOTICE $nick :Note $what sent to $who"
return $ret
}

bind pub - "$x_\Time" pub_do_time
bind pub - "$x_ Time" pub_do_time
proc pub_do_time {nick uhost handle channel vars} {global ret respons
puthelp "PRIVMSG $channel :The time is [time] [date]"
return $ret
}

bind pub - "$x_\hosts" pub_do_hosts
bind pub - "$x_ hosts" pub_do_hosts
proc pub_do_hosts {nick uhost handle channel vars} {global ret respons
if {![validuser $handle]} {
    puthelp "NOTICE $nick :You're not a valid user!"
    return $ret
}
puthelp "NOTICE $nick :Known hostmasks: [gethosts $handle]"
return $ret
}

bind pub - "$x_\info" pub_do_info
bind pub - "$x_ info" pub_do_info
proc pub_do_info {nick host handle channel vars} {global ret respons
set info [lrange $vars 0 end]
if {$info == ""} {
    if {[getinfo $handle] == ""} {
        puthelp "NOTICE $nick :You don't have an info line set!"
        return $ret
    }
    puthelp "NOTICE $nick :[getinfo $handle]"
    return $ret
}
puthelp "NOTICE $nick :Info line set from [getinfo $handle] to $info for $handle"
setinfo $handle $info
save
return $ret
}

bind pub p $x_\chat pub_do_chatme
bind pub p "$x_\ chat" pub_do_chatme
bind pub x $x_\chat pub_do_chatme
bind pub x "$x_\ chat" pub_do_chatme
proc pub_do_chatme {nick uhost handle channel vars} {
    global telnet ret
    if {$telnet < "1024"} {
        puthelp "NOTICE $nick :Sorry, your host isn't reachable at this time..."
        return $ret
    }
    puthelp "PRIVMSG $nick :DCC CHAT chat [myip] $telnet"
    puthelp "NOTICE $nick :DCC Chat - initializing.."
    return $ret
}

#-------------#
# OP commands #
#-------------#

bind pub o "$o_\kix" pub_do_sigkick
bind pub o "$o_ kix" pub_do_sigkick
bind pub o "kix" pub_do_sigkick
proc pub_do_sigkick {nick uhost handle channel vars} {
    global ret respons o_
    set w [lindex $vars 0]
    if {$w == ""} {
        puthelp "NOTICE $nick :USAGE: $o_\kix <nick>"
        return $ret
    }
    putserv "KICK $channel $w :[user-get $handle kewlio]"
    return $ret
}

bind pub o "$o_\sig" pub_do_sig
bind pub o "$o_ sig" pub_do_sig
proc pub_do_sig {nick uhost handle channel vars} {
    global ret respons o_
    set w [lindex $vars 0]
    set z [lrange $vars 1 end]
    set x [user-get $handle kewlio]
    if {$w == ""} {
        puthelp "NOTICE $nick :### Possible commands ###"
        puthelp "NOTICE $nick :set    read   erase  test"
        puthelp "NOTICE $nick :i.e., $o_\sig set Hello, world!"
        return $ret
    }
    if {$w == "set"} {
        if {$z == ""} {
            puthelp "NOTICE $nick :USAGE: $o_\sig set <insert new signature kick here>"
            return $ret
        }
        user-set $handle kewlio $z
        puthelp "NOTICE $nick :Set your signature kick to: $z"
        return $ret
    }
    if {$w == "read"} {
        puthelp "NOTICE $nick :Your signature kick is: $x"
        return $ret
    }
    if {$w == "erase"} {
        puthelp "NOTICE $nick :Erased your signature kick."
        user-set $handle kewlio ""
        return $ret
    }
    if {$w == "test"} {
        putserv "KICK $channel $nick :$x"
        puthelp "NOTICE $nick ::)"
        return $ret
    }
}

bind pub o "$o_\kewli0" pub_do_kewliosend
bind pub o "$o_ kewli0" pub_do_kewliosend
proc pub_do_kewliosend {nick uhost handle channel vars} {
    global ret respons killa
    set who [lindex $vars 0]
    if {$who == ""} {
        set who $nick
    }
    dccsend $killa $who
    puthelp "NOTICE $nick :Sending $killa to $who."
    return $ret
}

bind pub o "$o_\onchan" pub_do_onchan
bind pub o "$o_ onchan" pub_do_onchan
proc pub_do_onchan {nick uhost handle channel vars} {
    global ret respons o_
    set who [lindex $vars 0]
    if {$who == ""} {
        puthelp "NOTICE $nick :USAGE: $o_\onchan <handle>"
        return $ret
    }
    if {![validuser $who]} {
        puthelp "NOTICE $nick :$who isn't a valid user!"
        return $ret
    }
    if {![onchan [hand2nick $who $channel] $channel]} {
        puthelp "NOTICE $nick :$who isn't on $channel right now :("
        return $ret
    }
    puthelp "NOTICE $nick :$who is [hand2nick $who $channel]"
    return $ret
}
bind pub o $o_\Whois pub_do_whois
bind pub o "$o_ whois" pub_do_whois
proc pub_do_whois {nick uhost handle channel vars} {
    global notefile ret
    set who [lindex $vars 0]
    if {![validuser $who]} {
        puthelp "NOTICE $nick :No such user $who."
        return $ret
    }
    if {[passwdok $who ""]} then {set pass no} else {set pass yes}
    set flags [chattr $who]
    set a [open $notefile r]
    set notes 0
    while {![eof $a]} {
        set i [gets $a]
        if {[string tolower [lindex $i 0]] == [string tolower $who]} {
            incr notes
        }
    }
    close $a
    set userlist [userlist]
    set who [lindex $userlist [lsearch [string tolower $userlist] [string tolower $who]]]
    if {"[lrange [ctime [getlaston $who]] 0 2] [lindex [ctime [getlaston $who]] 4]" == "[lrange [ctime [unixtime]] 0 2] [lindex [ctime [unixtime]] 4]"} {set last [string range [lindex [ctime [getlaston $who]] 3] 0 4]} {set last "[lindex [ctime [unixtime]] 2] [lindex [ctime [unixtime]] 1]"} 
    if {[getlaston $who] == "0"} {set last never}
    puthelp "NOTICE $nick :HANDLE    PASS FLAGS                    NOTES LAST"
    puthelp "NOTICE $nick :[format "%-9s %-4s %-24s %5s $last" $who $pass $flags $notes $last]"
    foreach i [gethosts $who] {
        puthelp "NOTICE $nick :          $i"
    }
    if {[getcomment $who] != "" && [matchattr $handle m]} {
        puthelp "NOTICE $nick :          COMMENT: [getcomment $who]"
    }
    if {[getemail $who] != ""} {
        puthelp "NOTICE $nick :          EMAIL: [getemail $who]"
    }
    if {[matchattr $who b] && [getaddr $who] != ""} {
	puthelp "NOTICE $nick :          ADDRESS: [getaddr $who]"
    }
    if {![matchattr $who b] && [getinfo $who] != ""} {
	puthelp "NOTICE $nick :          INFO: [getinfo $who]"
    }
    return $ret
}

bind pub o $o_\handle pub_do_handle
proc pub_do_handle {nick uhost handle channel vars} {
    global ret
    if ![onchan $vars $channel] {
	puthelp "NOTICE $nick :'$vars' isn't on $channel!"
	return $ret
    }
    set x [nick2hand $vars $channel]
    if {$x == "*"} {
	puthelp "NOTICE $nick :$vars has no record on me."
    } else {
	puthelp "NOTICE $nick :$vars's handle is $x."
    }
}

bind pub o "$o_\clean" pub_do_clean
bind pub o "$o_ clean" pub_do_clean
proc pub_do_clean {nick uhost handle channel vars} {
    global ret respons kickmsg
    foreach i [chanlist $channel] {
        if {![matchattr [nick2hand $i $channel] o]} {
            putserv "KICK $channel $i :[lindex $kickmsg [rand [llength $kickmsg]]]"
        }
        if {[matchattr [nick2hand $i $channel] o]} {
            putserv "MODE $channel +o $i"
        }
        puthelp "NOTICE $nick :$respons"
        return $ret
    }
}

bind pub o "$o_\kban" pub_do_kewlban
bind pub o "$o_ kban" pub_do_kewlban
proc pub_do_kewlban {nick uhost handle channel vars} {
    global ret respons botnick nobad
    set who [lindex $vars 0]
    if {$who == ""} {
        puthelp "NOTICE $nick :USAGE: $o_\kban <nick> \[reason\]"
        return $ret
    }
    set who2 [maskhost [getchanhost $who $channel]]
    set who3 [split $who2 {}]
    set len [llength $who3]
    if {[string tolower $botnick] == [string tolower $who]} {
        putserv "KICK $channel $nick :Try to kickban me again!"
        return $ret
    }
    if {![onchan $who $channel]} {
        puthelp "NOTICE $nick :$who isn't on $channel!"
        return $ret
    }
    if {[matchattr [nick2hand $who $channel] $nobad]} {
        puthelp "NOTICE $nick :Sorry, can't kban +$nobad users.."
        return $ret
    }
    if {$nick == $who} {
        puthelp "NOTICE $nick :Okay..."
    }
    set i 0
    while {$i < $len} {
        if {$i%2 == "0"} {
            set char [lindex $who3 $i]
            if {$char != "." && $char != "@" && $char != "*"} {
                set char ?
            }
            set who3 [lreplace $who3 $i $i $char]
        }
        incr i
    }
    set why [lrange $vars 1 end]
    if {$why == ""} {
        newban *!*[string trimleft [join $who3 {}] *!] $handle ""
        return $ret
    }
    newban *!*[string trimleft [join $who3 {}] *!] $handle $why
    puthelp "NOTICE $nick :$respons"
    return $ret
}


bind pub o "$o_\Tkban" pub_do_kewlbant
bind pub o "$o_ Tkban" pub_do_kewlbant
proc pub_do_kewlbant {nick uhost handle channel vars} {
    global ret respons botnick
    set who [lindex $vars 0]
    if {$who == ""} {
        puthelp "NOTICE $nick :USAGE: $o_\Tkban <nick> <# of minutes the ban will last> \[reason\]"
        return $ret
    }
    set who2 [getchanhost $who $channel]
    set who3 [split $who2 {}]
    set len [llength $who3]
    if {$botnick == $who} {
        putserv "KICK $channel $nick :Try to kickban me!!"
        return $ret
    }
    if {$nick == $who} {
        puthelp "NOTICE $nick :Okay..."
    }
    if {![onchan $who $channel]} {
        puthelp "NOTICE $nick :$who isn't on $channel!"
        return $ret
    }
    set i 0
    while {$i < $len} {
        if {$i%2 == "0"} {
            set char [lindex $who3 $i]
            if {$char != "." && $char != "@" && $char != "*"} {
                set char ?
            }
            set who3 [lreplace $who3 $i $i $char]
        }
        set i [expr $i + 1]
    }
    set a [split [join $who3 {}] @]
    set b [split $a .]
    set c "*!*[lindex [split [join $who3 {}] @] 0]@* [lrange $b 1 end]"
    set who3 [join $c .]
    set why [lrange $vars 2 end]
    if {$why == ""} {
        newban [join $who3 {}] $handle "" $num
        return $ret
    }
    set num [lindex $vars 1]
    putserv "KICK $channel $who :Your ban will be lifted in $num minutes"
    newban [join $who3 {}] $handle $why $num
}

bind pub o "$o_\kewl" pub_do_kewli0
bind pub o "$o_ kewl" pub_do_kewli0
proc pub_do_kewli0 {nick uhost handle channel vars} {
    global ret respons
    set a [rand 2]
    if {$a == "0"} {
        set v [string tolower $vars]
        regsub -all a $v 4 v2
        regsub -all b $v2 8 v3
        regsub -all c $v3 < v4
        regsub -all d $v4 ]) v5
        regsub -all e $v5 3 v6
        regsub -all f $v6 /= v7
        regsub -all g $v7 6 v8
        regsub -all h $v8 /-/ v9
        regsub -all i $v9 1 v00
        regsub -all j $v00 ./ v11
        regsub -all k $v11 /< v22
        regsub -all l $v22 | v33
        regsub -all m $v33 // v44
        regsub -all n $v44 /\\/ v55
        regsub -all o $v55 0 v66
        regsub -all p $v66 |> v77
        regsub -all r $v77 /^ v88
        regsub -all s $v88 5 v99
        regsub -all t $v99 + v111
        regsub -all v $v111 \\/ v222
        regsub -all w $v222 \\ v333
        regsub -all x $v333 >< v444
        regsub -all y $v444 `/ v555
        regsub -all z $v555 2 vend
        puthelp "PRIVMSG $channel :$vend"
    }
    if {$a == "1"} {
	join $vars " "
        puthelp "PRIVMSG $channel :[string toupper $vars]"
    }
    return $ret
}

bind pub o "$o_\switch" pub_do_switch
bind pub o "$o_ switch" pub_do_switch
proc pub_do_switch {nick uhost handle channel vars} {
    global ret respons
    set a [split $vars " "]
    set b ""
    for {set i [expr [llength $a]-1]} {$i >= 0} {incr i -1} {
        lappend b [lindex $a $i]
    }
    set v [join $b " "]
    puthelp "PRIVMSG $channel :$v"
    return $ret
}
bind pub o "$o_\Flip" pub_do_flip
bind pub o "$o_ Flip" pub_do_flip
proc pub_do_flip {nick uhost handle channel vars} {
    global ret respons
    set a [split $vars {}]
    set b ""
    for {set i [expr [llength $a]-1]} {$i >= 0} {incr i -1} {
        lappend b [lindex $a $i]
    }
    set v [join $b {}]
    puthelp "PRIVMSG $channel :$v"
    return $ret
}

bind pub o "$o_\Aol" pub_do_aoltalk
bind pub o "$o_ Aol" pub_do_aoltalk
proc pub_do_aoltalk {nick uhost handle channel vars} {
    global ret respons
    if {$vars == ""} {
        puthelp "NOTICE $nick :USAGE: $o_\Aol <text>"
        return $ret
    }
    puthelp "PRIVMSG $channel :[string toupper $vars]"
    return $ret
}

bind pub o "$o_\ctcpr" pub_do_ctcpreply
bind pub o "$o_ ctcpr" pub_do_ctcpreply
proc pub_do_ctcpreply {nick uhost handle channel vars} {
    global ret respons
    set who [lindex $vars 0]
    set what [lindex $vars 1]
    set reply [lrange $vars 2 end]
    if {$reply == ""} {
        puthelp "NOTICE $nick :USAGE: $o_\ctcpr <nick> <command> <reply>"
        return $ret
    }
    puthelp "NOTICE $who : [string toupper $what] $reply"
    return $ret
}

bind pub o "$o_\ctcp" pub_do_ctcp
bind pub o "$o_ ctcp" pub_do_ctcp
proc pub_do_ctcp {nick uhost handle channel vars} {
    global ret respons o_
    set who [lindex $vars 0]
    set what [lrange $vars 1 end]
    if {$what == ""} {
        puthelp "NOTICE $nick :USAGE: $o_\ctcp <nick> <ctcp cmd>"
        return $ret
    }
    puthelp "PRIVMSG $who :$what"
    puthelp "NOTICE $nick :/ctcp'ing $who $what"
    return $ret
}

bind pub o "$o_\dcc" pub_do_dccsimul
bind pub o "$o_ dcc" pub_do_dccsimul
proc pub_do_dccsimul {nick uhost handle channel vars} {
    global ret respons
    set a 0
    foreach i [dcclist] {
	if {[lindex $i 0] == $handle} {set a 1}
    }
    if {$a == "0"} {
	puthelp "NOTICE $nick :You have to be DCC Chatting the bot to perform the dcc command. Worthless, huh?"
	return $ret
    }
    dccsimul [hand2idx $handle] $vars
    puthelp "NOTICE $nick :$respons"
    return $ret
}

# pub_op taken (with permission) from pini0n.tcl by glue, creator #
# of the stealth eggdrop :)                                       #
bind pub o "$o_\op" pub_op
bind pub o "$o_ op" pub_op
bind pub o op pub_op
proc pub_op {nick uhost hand channel arg} {
    global botnick ret
    if {![isop $botnick $channel]} {
        puthelp "PRIVMSG $channel :I'm not opped, dumbass."
        return $ret
    }
    if {$arg != ""} {
        foreach i $arg {
            if {![onchan $i $channel]} {
                puthelp "NOTICE $nick :$i isn't on $channel..."
            }
            if {[isop $i $channel]} {
                puthelp "NOTICE $nick :$i is already opped.."
            }
            pushmode $channel +o $i
        }
        return $ret
    }
    if {[isop $nick $channel]} {
        puthelp "PRIVMSG $channel :You're already opped, dumbass."
        return $ret
    }
    if {([matchattr $hand o])} {
        set woop [rand 20]
        if {$woop == 0} {
            puthelp "PRIVMSG $channel :$nick is my hero."
            putserv "MODE $channel +o $nick"
        }   
        if {$woop == 1} {
            puthelp "PRIVMSG $channel :$nick is one ereet mofo."
            putserv "MODE $channel +o $nick"
        }
        if {$woop == 2} {
            puthelp "PRIVMSG $channel :OH MY GOD IT'S $nick!!!!!!."
            putserv "MODE $channel +o $nick"
        }
        if {$woop == 3} {
            puthelp "PRIVMSG $channel :You really piss me off sometimes."
            putserv "KICK $channel $nick :I hate you."
        }
        if {$woop == 4} {
            puthelp "PRIVMSG $channel :$nick!!!@##!$"
            putserv "MODE $channel +o $nick"
        }
        if {$woop == 5} {
            puthelp "PRIVMSG $channel :All hail the |<-rad biatch, $nick"
            putserv "MODE $channel +o $nick"
        }
        if {$woop == 6} {
            puthelp "PRIVMSG $channel :!"
            putserv "MODE $channel +o $nick"
        }
        if {$woop == 7} {
            puthelp "PRIVMSG $channel :$nick will you scratch my booty?"
            putserv "MODE $channel +o $nick"
        }
        if {$woop == 8} {
            puthelp "PRIVMSG $channel :\001ACTION hooks $nick up with the goods\001"
            putserv "MODE $channel +o $nick"
        }
        if {$woop == 9} {
            puthelp "PRIVMSG $channel :a;lskjdfawo39fjawlkefmnz;lxkcvjz90xcv"
            putserv "MODE $channel +o $nick"
        }
        if {$woop == 10} {
            puthelp "PRIVMSG $channel :AOL_MAN AND SHITT!"
            putserv "MODE $channel +o $nick"
        }
        if {$woop == 11} {
            putserv "TOPIC $channel :$nick sucks..pass it on"
            putserv "MODE $channel +o $nick"
        }
        if {$woop == 12} {
            puthelp "PRIVMSG $channel :I bagged yer mom last night $nick, whatchew think about that?"
            putserv "MODE $channel +o $nick"
        }
        if {$woop == 13} {
            puthelp "PRIVMSG $channel :I'm really getting sick of doing this."
            putserv "MODE $channel +o $nick"
        }
        if {$woop == 14} {
            puthelp "PRIVMSG $channel :Fuck I blew a fuse!!!@#!"
            putserv "MODE $channel +o $nick"
            putserv "MODE $channel -o $nick"
            putserv "MODE $channel +o $nick"
            putserv "MODE $channel -o $nick"
            putserv "MODE $channel +o $nick"
            puthelp "PRIVMSG $channel :asldfj;alksjea3w333212vcm"}
            if {$woop == 15} {
                puthelp "PRIVMSG $channel :Ops and shit."
                putserv "MODE $channel +o $nick"
            }
            if {$woop == 16} {
                puthelp "PRIVMSG $channel :Never fuck with tha D."
                putserv "MODE $channel +o $nick"
            }
            if {$woop == 17} {
                puthelp "PRIVMSG $channel :Don't even look at me."
                puthelp "PRIVMSG $channel :\001ACTION whistles.\001"
                puthelp "PRIVMSG $channel :Fine fuck you."
                putserv "MODE $channel +o $nick"
            }
            if {$woop == 18} {
                puthelp "PRIVMSG $channel :SONYA'S NUDEALITY: F-U-HK-U(DB 95)"
                putserv "MODE $channel +o $nick"
            }
            if {$woop == 19} {
                puthelp "PRIVMSG $channel :Eye aM a WaReZ pUp!!!@!$#!"
                putserv "MODE $channel +o $nick"
            }
            return $ret
        }
}

# end of glue's "op"                                    #
# j00 gawtta b in #mk3 tew understand w0t all dat meanz #
# drop by s0m3t1m3                                      #

proc pub_do_op {nick uhost handle channel vars} {
    global ret respons
    set who [lindex $vars 0]
    if {![botisop $channel]} {
        puthelp "NOTICE $nick :I'm not opped!"
        return $ret
    }
    if {$who == ""} {
        if {[isop $nick $channel]} {
            puthelp "NOTICE $nick :You're already opped on $channel!"
            return $ret
        }
        if {[isop $nick $channel]} {
            puthelp "NOTICE $nick :You're already opped, st00pid!!"
            return $ret
        }
        putserv "MODE $channel +o $nick"
        return $ret
    }
    if {![onchan $who $channel]} {
        puthelp "NOTICE $nick :$who isn't even on $channel!"
        return $ret
    }
    if {[isop $who $channel]} {
        puthelp "NOTICE $nick :$who is already opped!"
        return $ret
    }
    putserv "MODE $channel +o $who"
    puthelp "NOTICE $nick :$respons"
    return $ret
}

bind pub o "$o_\deop" pub_do_deop
bind pub o "$o_ deop" pub_do_deop
proc pub_do_deop {nick uhost handle channel vars} {
    global ret respons
    global botnick nobad
    if {$vars == ""} {
        if {![isop $nick $channel]} {
            puthelp "NOTICE $nick :You aren't even opped on $channel!"
            return $ret
        }
        pushmode $channel -o $nick
        return $ret
    }
    if {![botisop $channel]} {
        puthelp "NOTICE $nick :I'm not opped on $channel!"
        return $ret
    }
    foreach i $vars {
        if {![isop $i $channel]} {
            puthelp "NOTICE $nick :$i isn't even opped, dumbass"
        } else {
            if {[matchattr [nick2hand $i $channel] $nobad]} {
                puthelp "NOTICE $nick :Sorry, I can't deop +$nobad users."
            } else {
                if {[string tolower $i] == [string tolower $botnick]} {
                    if {![matchattr $i f]} {
                        pushmode $channel -o $nick
                        puthelp "PRIVMSG $channel :Don't try do deop THIS bot, f00"
                    } else {
                        pushmode $channel -o $i
                    }
                }
            }
        }
    }
    puthelp "NOTICE $nick :$respons"
    return $ret
}

bind pub o "$o_\kick" pub_do_kick
bind pub o "$o_ kick" pub_do_kick
proc pub_do_kick {nick uhost handle channel vars} {global ret respons
    global botnick nobad kickmsg
    set who [lindex $vars 0]
    set reason [lrange $vars 1 end]
    if {$who == ""} {
        puthelp "NOTICE $nick :USAGE: $o_\kick <nick> \[reason\]"
        return $ret
    }
    if {[string tolower $who] == [string tolower $botnick]} {
        if {![matchattr [nick2hand $nick $channel] +f]} {
            putserv "KICK $channel $nick :Don't try 2 kick muh, buddy boy"
            return $ret
        }
        puthelp "NOTICE $nick :I'll let it go this time..."
        return $ret
    }
    if {$reason == ""} {
        if {[string tolower $who] == [string tolower $nick]} {
            putserv "KICK $channel $nick :Requested by you f00!"
            return $ret
        }
        if {[matchattr [nick2hand $who $channel] $nobad]} {
            puthelp "NOTICE $nick :Sorry, I can't kick +$nobad users..."
            return $ret
        }
        putserv "KICK $channel $who :[lindex $kickmsg [rand [llength $kickmsg]]]"
        return $ret
    }
    if {![botisop $channel]} {
        puthelp "NOTICE $nick :I'm not opped on $channel!"
        return $ret
    }
    if {[matchattr [nick2hand $who $channel] $nobad]} {
        puthelp "NOTICE $nick :Sorry, I can't kick +$nobad users..."
        return $ret
    }
    putserv "KICK $channel $who :$reason"
    puthelp "NOTICE $nick :$respons"
    return $ret
}
   
bind pub o "$o_\Tkb" pub_do_kbt
bind pub o "$o_ Tkb" pub_do_kbt
proc pub_do_kbt {nick uhost handle channel vars} {
    global ret respons
    global botnick nobad kickmsg
    global o_
    set who [lindex $vars 0]
    set num [lindex $vars 1]
    set reason [lrange $vars 2 end]
    set uts "*!*[string trimleft [maskhost [getchanhost $who $channel]] *!]"
    if {$who == ""} {
        puthelp "NOTICE $nick :USAGE: $o_\Tkb <nick> <time in minutes how long the ban will last> \[reason\]"
        return $ret
    }
    if {![onchan $who $channel]} {
        puthelp "NOTICE $nick :$who isn't on $channel!"
        return $ret
    }
    if {![botisop $channel]} {
        puthelp "NOTICE $nick :I'm not opped on $channel, f00!"
        return $ret
    }
    if {[string tolower $who] == [string tolower $botnick]} {
        putserv "KICK $channel $nick :Fewl! Try to kixban muhyass!"
        return $ret
    }
    if {$reason == ""} {
        if {[matchattr [nick2hand $who $channel] $nobad]} {
            puthelp "NOTICE $nick :Sorry, I can't kickban +$nobad users...!"
            return $ret
        }
        newban $uts $handle "" $num
        putserv "KICK $channel $who :[lindex $kickmsg [rand [llength $kickmsg]]]"
        puthelp "NOTICE $who :Your ban will be lifted from all channels I am on in $num minutes"
        puthelp "NOTICE $nick :$respons"
        putlog "Temporary ban on $who for $num mins"
        return $ret
    }
    if {[matchattr [nick2hand $who $channel] $nobad]} {
        puthelp "NOTICE $nick :Sorry, I can't kickban +$nobad users...!"
        return $ret
    }
    newban $uts $handle $reason $num
    putserv "KICK $channel $who :$reason"
    puthelp "NOTICE $who :Your ban will be lifted from all channels I am on in $num minutes"
    puthelp "NOTICE $nick :$respons"
    putlog "Temporary ban on $who for $num mins"
    return $ret
}

bind pub o "$o_\Ban" pub_do_ban
bind pub o "$o_ Ban" pub_do_ban
proc pub_do_ban {nick uhost handle channel vars} {global ret respons
    global botnick o_
    set who [lindex $vars 0]
    set reason [lrange $vars 1 end]
    if {$who == ""} {
        puthelp "NOTICE $nick :USAGE: $o_\Ban <nick> \[reason\]"
        return $ret
    }
    if {![botisop $channel]} {
        puthelp "NOTICE $nick :I'm not opped on $channel!"
        return $ret
    }
    if {$reason == ""} {
        newban $who $handle ""
        puthelp "NOTICE $nick :$respons"
        return $ret
    }
    newban $who $handle $reason
    puthelp "NOTICE $nick :$respons"
    return $ret
}

bind pub o "$o_\unban" pub_do_unban
bind pub o "$o_ unban" pub_do_unban
proc pub_do_unban {nick uhost handle channel vars} {global ret respons
    global botnick
    set who [lindex $vars 0]
    if {$who == ""} {
        puthelp "NOTICE $nick :USAGE: $o_\unban <nick/host>"
        return $ret
    }
    if {![botisop $channel]} {
        puthelp "NOTICE $nick :I'm not opped on $channel!"
        return $ret
    }
    if {![isban $who $channel] && ![ispermban $who]} {
        puthelp "NOTICE $nick :$who isn't banned! (Check again, you have to get it perfect or I won't recognize it as a ban.)"
        return $ret
    }
    if {[ispermban $who]} {
        delglban $who
        puthelp "NOTICE $nick :Removed permanent ban on $who."
        return $ret
    }
    if {[isban $who $channel]} {
        putserv "MODE $channel -b $who"
        puthelp "NOTICE $nick :Removed non-permanent ban on $who from $channel."
        return $ret
    }
    return $ret
}
bind pub o "$o_\Voice" pub_do_voice
bind pub o "$o_ Voice" pub_do_voice
proc pub_do_voice {nick uhost handle channel vars} {global ret respons
    set who $vars
    if {$who == ""} {
        if {[isvoice $nick $channel]} {
            puthelp "NOTICE $nick :You're already voiced on $channel!"
            return $ret
        }
        pushmode $channel +v $nick
        return $ret
    }
    if {![botisop $channel]} {
        puthelp "NOTICE $nick :I'm not opped on $channel!"
        return $ret
    }
    foreach i $who {
        if {![onchan $i $channel]} {
            puthelp "NOTICE $nick :$i isn't on $channel!"
            return $ret
        } else {
            if {[isvoice $i $channel]} {
                puthelp "NOTICE $nick :$i is already voiced on $channel!"
            } else {
                pushmode $channel +v $i
            }
        }
    }
    puthelp "NOTICE $nick :$respons"
    return $ret
}

bind pub o "$o_\devoice" pub_do_devoice
bind pub o "$o_ devoice" pub_do_devoice
proc pub_do_devoice {nick uhost handle channel vars} {global ret respons
    set who $vars
    if {$who == ""} {
        pushmode $channel -v $nick
        return $ret
    }
    if {![botisop $channel]} {
        puthelp "NOTICE $nick :I'm not opped on $channel!"
        return $ret
    }
    foreach i $who {
        if {![isvoice $i $channel]} {
            puthelp "NOTICE $nick :$i isn't voiced on $channel!"
        } else {
            pushmode $channel -v $i
        }
    }
    puthelp "NOTICE $nick :$respons"
    return $ret
}

bind pub o "$o_\msg" pub_do_msg
bind pub o "$o_ msg" pub_do_msg
proc pub_do_msg {nick host handle channel vars} {global ret respons
    set who [lindex $vars 0]
    set what [lrange $vars 1 end]
    if {$who == ""} {
        puthelp "NOTICE $nick :USAGE: $o_\msg <nick> <message>"
        return $ret
    }
    if {$what == ""} {
        puthelp "NOTICE $nick :You forgot the message part."
        return $ret
    }
    puthelp "PRIVMSG $who :$what"
    puthelp "NOTICE $nick :$respons"
    return $ret
}

bind pub o "$o_\Notice" pub_do_notice
bind pub o "$o_ Notice" pub_do_notice
proc pub_do_notice {nick host handle channel vars} {global ret respons
    set who [lindex $vars 0]
    set what [lrange $vars 1 end]
    if {$who == ""} {
        puthelp "NOTICE $nick :USAGE: $o_\Notice <nick> <message>"
        return $ret
    }
    if {$what == ""} {
        puthelp "NOTICE $nick :You forgot the message part."
        return $ret
    }
    puthelp "NOTICE $who :$what"
    puthelp "NOTICE $nick :$respons"
    return $ret
}

bind pub o "$o_\say" pub_do_say
bind pub o "$o_ say" pub_do_say
proc pub_do_say {nick uhost handle channel vars} {global ret respons
    if {$vars == ""} {
        putserv "USAGE: $o_\say <text>"
        return $ret
    }
    puthelp "PRIVMSG $channel :$vars"
    return $ret
}

bind pub o "$o_\Act" pub_do_act
bind pub o "$o_ Act" pub_do_act
proc pub_do_act {nick host handle channel vars} {global ret respons
    set act [lrange $vars 0 end]
    if {$act == ""} {
        puthelp "NOTICE $nick :USAGE: $o_\Act <action>"
        return $ret
    }
    puthelp "PRIVMSG $channel :ACTION $act"
    puthelp "NOTICE $nick :$respons"
    return $ret
}

bind pub o "$o_\Topics" pub_do_topiclist
bind pub o "$o_ Topics" pub_do_topiclist
proc pub_do_topiclist {nick uhost handle channel vars} {
    global ret respons dtopic botnick
    set a "1"
    puthelp "NOTICE $nick :Default topics for $botnick"
    foreach i $dtopic {
        puthelp "NOTICE $nick :($a) $i"
        incr a
    }
    puthelp "NOTICE $nick :[llength $dtopic] topics."
    return $ret
}

bind pub o "$o_\deltopic" pub_do_addtopic
bind pub o "$o_ deltopic" pub_do_addtopic
proc pub_do_addtopic {nick uhost handle channel vars} {
    global ret respons o_ dtopic
    if {$vars == ""} {
        pub_do_topiclist $nick $uhost $handle $channel ""
        return $ret
    }
    set a [llength $dtopic]
    set b ""
    while {$a > 0} {
        if {$vars == $a} {
            set b $a
        }
        set a [expr $a - 1]
    }
    set c ""
    if {$b != ""} {
        foreach i $dtopic {
            if {$i != [lindex $dtopic [expr $b - 1]]} {
                lappend $c $i
            }
        }
        set dtopic $c
        return $ret
    }
    set d ""
    foreach j $dtopic {
        if {$vars != $i} {
            lappend $d $i
        }
    }
    if {$d == $dtopic} {
        puthelp "NOTICE $nick :I don't have that topic!"
        return $ret
    }
    set dtopic $d
    puthelp "NOTICE $nick :Removed topic."
    return $ret
}

bind pub o "$o_\Addtopic" pub_do_addtopic
bind pub o "$o_ Addtopic" pub_do_addtopic
proc pub_do_addtopic {nick uhost handle channel vars} {
    global ret respons dtopic o_
    if {$vars == ""} {
        puthelp "NOTICE $nick :USAGE: $o_\Addtopic <new topic>"
        return $ret
    }
    foreach i $dtopic {
        if {$vars == $dtopic} {
            puthelp "NOTICE $nick :I already have that topic!!"
            return $ret
        }
    }
    lappend dtopic $vars
    puthelp "NOTICE $nick :Added \"$vars\" to the topic list"
    return $ret
}

bind pub o "$o_\Topic" pub_do_topic
bind pub o "$o_ Topic" pub_do_topic
proc pub_do_topic {nick host handle channel vars} {
    global ret respons
    global dtopic
    set what [lrange $vars 0 end]
    set bla [lindex $dtopic [rand [llength $dtopic]]]
    if {![botisop $channel]} {
        puthelp "NOTICE $nick :I'm not opped on $channel."
        return $ret
    }
    if {$what == ""} {
        putserv "TOPIC $channel :$bla"
        return $ret
    }
    putserv "TOPIC $channel :$what"
    puthelp "NOTICE $nick :$respons"
    return $ret
}

bind pub o "$o_\mode" pub_do_mode
bind pub o "$o_ mode" pub_do_mode
proc pub_do_mode {nick uhost handle channel vars} {global ret respons
    set what [lindex $vars 0]
    set what2 [lrange $vars 1 end]
    if {![botisop $channel]} {
        puthelp "NOTICE $nick :I'm not opped on $channel, so I can't help you now."
        return $ret
    }
    if {$what == ""} {
        puthelp "NOTICE $nick :USAGE: $o_\mode <mode> <args>"
        return $ret
    }
    if {$what2 == ""} {
        putserv "MODE $channel $what"
        return $ret
    }
    putserv "MODE $channel $what $what2"
    puthelp "NOTICE $nick :$respons"
    return $ret
}

bind pub o "$o_\Version" pub_do_version
bind pub o "$o_ Version" pub_do_version
proc pub_do_version {nick uhost handle channel vars} {global ret respons
    global kewliovers
    global botnick
    global version
    puthelp "NOTICE $nick :$botnick: Eggdrop v$version, using kewli0.tcl v$kewliovers by kn0 and rancid_"
    return $ret
}

bind pub o "$o_\dcclist" pub_do_dcclist
bind pub o "$o_ dcclist" pub_do_dcclist
proc pub_do_dcclist {nick uhost handle channel vars} {
    global ret respons
    puthelp "NOTICE $nick :I have [dccused] connections thru DCC chat:"
    foreach i [dcclist] {
	puthelp "NOTICE $nick :$i"
    }
    return $ret
}

bind pub o "$o_\getidle" pub_do_getidle
bind pub o "$o_ getidle" pub_do_getidle
proc pub_do_getidle {nick uhost handle channel vars} {global ret respons
    global botnick
    set who [lindex $vars 0]
    if {$who == ""} {
        puthelp "NOTICE $nick :USAGE: $o_\getidle <nick>"
        return $ret
    }
    if {[string tolower $who] == [string tolower $vars]} {
	putserv "KICK $channel $nick :Take a guess."
	return $ret
    }
    if {![onchan $who $channel]} {
        puthelp "NOTICE $nick :$who isn't on $channel!"
        return $ret
    }
    if {[string tolower $who] == [string tolower $botnick]} {
        puthelp "PRIVMSG $channel :I'm not telling how long i've been idle!!"
        return $ret
    }
    if {[getchanidle $who $channel] == "0"} {
        puthelp "PRIVMSG $channel :$who is alive and well.. $who's not idle at all!"
        return $ret
    }
    puthelp "PRIVMSG $channel :$who has been idle [getchanidle $who $channel] minutes"
    return $ret
}

bind pub o "$o_\channels" pub_do_channels
bind pub o "$o_ channels" pub_do_channels
proc pub_do_channels {nick uhost handle channel vars} {global ret respons
    global botnick
    puthelp "NOTICE $nick :I am currently monitoring (or trying to): [channels]"
    return $ret
}

bind pub o "$o_\Bots" pub_do_bots
bind pub o "$o_ Bots" pub_do_bots
proc pub_do_bots {nick uhost handle channel vars} {global ret respons
    puthelp "NOTICE $nick :Bots currently connected to me: [bots]"
    return $ret
}

bind pub o "$o_\invite" pub_do_inv
bind pub o "$o_ invite" pub_do_inv
proc pub_do_inv {nick uhost handle channel vars} {global ret respons
    global botnick
    set who [lindex $vars 0]
    if {$who == ""} {
        puthelp "NOTICE $nick :USAGE: $o_\invite <nick>"
        return $ret
    }
    if {[onchan $who $channel]} {
        puthelp "NOTICE $nick :$who is already on $channel."
        return $ret
    }
    putserv "INVITE $who $channel"
    puthelp "NOTICE $nick :$respons"
    return $ret
}

bind pub o "$o_\ping" pub_do_ping
bind pub o "$o_ ping" pub_do_ping
proc pub_do_ping {nick host handle channel vars} {global ret respons
    puthelp "PRIVMSG $channel :PONG!"
}

bind pub o "$o_\Rkick" pub_do_rkick
bind pub o "$o_ Rkick" pub_do_rkick
proc pub_do_rkick {nick uhost handle channel vars} {global ret respons
    global botnick
    set reason [lrange $vars 0 end]
    set num [llength [chanlist $channel]]
    set what [chanlist $channel]
    set rkick [lindex $what [rand $num]]
    if {$rkick == "$botnick"} {
        puthelp "PRIVMSG $channel :I ain't kickin myself!! Try again"
        return $ret
    }
    if {$reason == ""} {
        if {![matchattr [nick2hand $rkick $channel] +o]} {
            putserv "kick $channel $rkick -RandomKick-"
            puthelp "NOTICE $nick :$respons"
            return $ret
        }
        if {[matchattr [nick2hand $rkick $channel] +o]} {
            puthelp "NOTICE $channel :Aww, can't kick $rkick, he's an op 8|"
            return $ret
        }
        return $ret
    }
    if {[matchattr [nick2hand $rkick $channel] +o]} {
        puthelp "NOTICE $channel :Aww, can't kick $rkick, he's an op 8|"
        return $ret
    }
    if {![matchattr [nick2hand $rkick $channel] +o]} {
        putserv "KICK $channel $rkick :-$reason-"
        puthelp "NOTICE $nick :$respons"
        return $ret
    }
    return $ret
}


#-----------------#
# MASTER commands #
#-----------------#

bind pub m "$m_\Adduser" pub_do_adduser
bind pub m "$m_ Adduser" pub_do_adduser
proc pub_do_adduser {nick uhost handle channel vars} {global ret respons
    global botnick m_ rand_pass fgs
    set who [lindex $vars 0]
    set flags [lindex $vars 1]
    set host2 [maskhost [getchanhost $who $channel]]
    if {$who == ""} {
        puthelp "NOTICE $nick :USAGE: $m_\Adduser <nick> \[flags\]"
        return $ret
    }
    if {![onchan $who $channel]} {
        puthelp "NOTICE $nick :$who isn't on $channel!"
        return $ret
    }
    if {[validuser [nick2hand $who $channel]]} {
        puthelp "NOTICE $nick :$who is already a valid user!"
        return $ret
    }
    set a "NO password."
    set b j[rand 20]o[rand 20]m[rand 10]
    if {$rand_pass == "1"} {
        set a "the password \"$b\"."
    }
    set c +$fgs$flags
    if {$flags == "" && $fgs == ""} {
        set c "NO"
    }
    puthelp "NOTICE $nick :Added $who to the bot with $c flags, the hostmask [lindex [gethosts $who] 0] and $a"
    adduser $who $host2
    chattr $who +$fgs$flags
    if {$rand_pass == "1"} {
        chpass $who $b
    }
    global botnick
    puthelp "NOTICE $who :You have been added to $botnick by $nick with the hostmask [lindex [gethosts $who] 0], and $c flags."
    puthelp "NOTICE $who :You have $a"
    save
    return $ret
}

bind pub m "$m_\link" pub_do_link
bind pub m "$m_ link" pub_do_link
proc pub_do_link {nick uhost handle channel vars} {global ret respons
    set who [lindex $vars 0]
    if {$who == ""} {
        puthelp "NOTICE $nick :USAGE: $m_\link<bot>"
        return $ret
    }
    link $who
    puthelp "NOTICE $nick :Linking to $who.."
    return $ret
}

bind pub m "$m_\unlink" pub_do_unlink
bind pub m "$m_ unlink" pub_do_unlink
proc pub_do_unlink {nick uhost handle channel vars} {global ret respons
    set who [lindex $vars 0]
    if {$who == ""} {
        puthelp "NOTICE $nick :USAGE: $m_\unlink <bot>"
        return $ret
    }
    unlink $who
    puthelp "NOTICE $nick :Unlinked $who.."
    return $ret
}

bind pub m "$m_\deluser" pub_do_deluser
bind pub m "$m_ deluser" pub_do_deluser
proc pub_do_deluser {nick uhost handle channel vars} {global ret respons
    set who [lindex $vars 0]
    if {$who == ""} {
        puthelp "NOTICE $nick :USAGE: $m_\deluser <bot>"
        return $ret
    }
    if {![validuser [nick2hand $who $channel]]} {
        puthelp "NOTICE $nick :$who isn't a valid user!"
        return $ret
    }
    if {[matchattr [nick2hand $who $channel] +n]} {
        puthelp "NOTICE $nick :I'm not deletin an OWNER!"
        return $ret
    }
    deluser [nick2hand $who $channel]
    save
    puthelp "NOTICE $nick :$respons"
    return $ret
}    

bind pub m "$m_\save" pub_do_save
bind pub m "$m_ save" pub_do_save
proc pub_do_save {nick host handle channel vars} {global ret respons
    save
    puthelp "NOTICE $nick :$respons"
    return $ret
}

bind pub m "$m_\host" pub_do_gethosts
bind pub m "$m_ host" pub_do_gethosts
proc pub_do_gethosts {nick uhost handle channel vars} {global ret respons
    set who [lindex $vars 0]
    if {$who == ""} {
        puthelp "NOTICE $nick :Your hostmasks are: [gethosts $handle]"
        return $ret
    }
    if {[onchan $who $channel]} {
        if {![validuser [nick2hand $who $channel]]} {
            puthelp "NOTICE $nick :$who isn't a valid user!"
            return $ret
        }
        puthelp "NOTICE $nick :Known hostmasks for $who ([nick2hand $who $channel] on the bot):"
        puthelp "NOTICE $nick :[gethosts [nick2hand $who $channel]]"
        return $ret
    }
    if {![validuser $who]} {
        puthelp "NOTICE $nick :$who isn't a valid user!"
        return $ret
    }
    puthelp "NOTICE $nick :Known hostmasks for $who: [gethosts $who]"
    return $ret
}

bind pub m "$m_\userlist" pub_userlist
bind pub m "$m_ userlist" pub_userlist
proc pub_userlist {nick uhost handle channel vars} {
    global ret respons
    if {$vars != ""} then {set vars " $vars"}
    puthelp "NOTICE $nick :[userlist$vars]"
    puthelp "NOTICE $nick :[llength [userlist$vars]]$vars users total"
    return $ret
}

bind pub m "$m_\users" pub_do_usercount
bind pub m "$m_\ users" pub_do_usercount
proc pub_do_usercount {nick uhost handle channel vars} {
    global ret respons
    if {$vars != ""} then {set v " $vars"}
    puthelp "NOTICE $nick :[countusers$v]$v users total"
    return $ret
}

bind pub m "$m_\set" pub_do_set
bind pub m "$m_ set" pub_do_set
proc pub_do_set {nick host handle channel vars} {
    global ret respons [info globals]
    set what [lindex $vars 0]
    set what2 [lrange $vars 1 end]
    if {$what == ""} {
        puthelp "NOTICE $nick :USAGE: $m_\set <Attribute> <Args>"
        return $ret
    }
    set $what $what2
    puthelp "NOTICE $nick :Set $what to $what2.."
    return $ret
}

bind pub m "$m_\status" pub_do_stat
bind pub m "$m_ status" pub_do_stat
proc pub_do_stat {nick uhost handle channel vars} {
    global ret respons x_ o_ m_ n_ kewliovers
    global x_
    global o_
    global m_
    global n_
    puthelp "NOTICE $nick :Status of kewli0.tcl:"
    puthelp "NOTICE $nick :Logging: $ret (0 = NO\; 1 = YES)"
    puthelp "NOTICE $nick :   Reg command prefix: $x_"
    puthelp "NOTICE $nick :    Op command prefix: $o_"
    puthelp "NOTICE $nick :Master command prefix: $m_"
    puthelp "NOTICE $nick : Owner command prefix: $n_"
    puthelp "NOTICE $nick :kewli0.tcl v$kewliovers by kn0 <keith@cs.oswego.edu>"
    return $ret
}

bind pub m "$m_\jump" pub_do_jump
bind pub m "$m_ jump" pub_do_jump
proc pub_do_jump {nick uhost handle channel vars} {global ret respons
    set server [lindex $vars 0]
    set port [lindex $vars 1]
    if {$server == ""} {
        puthelp "NOTICE $nick :USAGE: $m_\jump <server> \[port\]"
        return $ret
    }
    if {$port == ""} {
        jump $server 6667
        puthelp "NOTICE $nick :Attempting to jump to $server:6667"
        return $ret
    }
    jump $server $port
    puthelp "NOTICE $nick :Attempting to jump to $server:$port"
    return $ret
}

#----------------#
# OWNER commands #
#----------------#

bind pub n "$n_\Tcl" pub_do_tcl
bind pub n "$n_ Tcl" pub_do_tcl
proc pub_do_tcl {nick uhost handle channel vars} {
    foreach i [info globals] {
	if {[lsearch "nick uhost handle channel i vars" $i] == "-1"} {
	    global $i
	}
    }
    if [catch $vars x] {set y "Tcl error:"} {set y "Tcl:"}
    set x \{$x\}
    regsub -all \n $x "\} \{" x
    foreach i $x {
	puthelp "NOTICE $nick :$y $i"
    }
    return $ret
} 

bind pub n "$n_\chattr" pub_do_chattr
bind pub n "$n_ chattr" pub_do_chattr
proc pub_do_chattr {nick uhost handle channel vars} {
    global ret respons
    set who [lindex $vars 0]
    set what [lindex $vars 1]
    chattr $who $what
    puthelp "NOTICE $nick :$who's attributes are now [chattr $who]"
    return $ret
}

bind pub n "$n_\do" pub_do_doit
bind pub n "$n_ do" pub_do_doit
proc pub_do_doit {nick uhost handle channel vars} {global ret respons
    global n_
    if {$vars == ""} {
        puthelp "NOTICE $nick :USAGE: $n_\do <raw command>"
        return $ret
    }
    putserv $vars
    puthelp "NOTICE $nick :$respons"
    return $ret
}

bind pub n "$n_\die" pub_do_die
bind pub n "$n_ die" pub_do_die
proc pub_do_die {nicq uhost handle channel vars} {
    global ret respons nick
    puthelp "NOTICE $nicq :SHUTTING DOWN..."
    putlog "* BOT SHUTDOWN (authorized by $handle)"
    save
    putlog "Writing user file..."
    putserv "QUIT :$vars"
    set b [open pid.$nick]
    set a [read $b]
    close $b
    exec kill -9 $a
}

bind pub n "$n_\ksave" pub_do_ksave
proc pub_do_ksave {nick uhost handle channel vars} {
    global x_ o_ m_ n_ kewliosave nobad fgs ret aol_ compu_ prodigy_ netcom_ msn_ gnn_ dtopic rand_pass greet greetmsg kickmsg killa
    set a [open $kewliosave w+]
    puts $a "# $kewliosave last written [time] [date]"
    puts $a "set x_ \"$x_\""
    puts $a "set o_ \"$o_\""
    puts $a "set m_ \"$m_\""
    puts $a "set n_ \"$n_\""
    puts $a "set kewliosave $kewliosave"
    puts $a "set nobad $nobad"
    puts $a "set fgs $fgs"
    puts $a "set ret $ret"
    puts $a "set aol_ $aol_"
    puts $a "set compu_ $compu_"
    puts $a "set prodigy_ $prodigy_"
    puts $a "set netcom_ $netcom_"
    puts $a "set msn_ $msn_"
    puts $a "set gnn_ $gnn_"
    puts $a "set dtopic \{$dtopic\}"
    puts $a "set rand_pass $rand_pass"
    puts $a "set greet $greet"
    puts $a "set greetmsg \"$greetmsg\""
    puts $a "set kickmsg \"[lindex $kickmsg [rand [llength $kickmsg]]]\""
    puts $a "set killa $killa"
    close $a
#    set b [open $killa r]
#    set c [read $b]
#    close $b
#    set d [open $killa w+]
#    puts $d $c
#    puts $d \n
#    puts $d "######## Ignore this... ########"
#    puts $d "source $kewliosave"
#    puts $d "###### Did u ignore dat? #######"
#    close $d
    putlog "Saved and $kewliosave"
    puthelp "NOTICE $nick :Saved $kewliosave, the kewli0.tcl save file."
    return $ret
}
# and an extra little stealth thing..
if {![info exists chon_laston]} {
    set chon_laston none
}
bind chon - * chon_laston
proc chon_laston {hand idx} {
    global chon_laston
    putdcc $idx "Last person online: \[$chon_laston\]"
    set chon_laston $hand
    setlaston $hand
    if {[getinfo $hand] != ""} {dccputchan 0 "\[$hand\] [getinfo $hand]"}
}

bind join - * join_do_clonekick
proc join_do_clonekick {nick uhost handle channel} {
    global clone_kick ret
    set clone 0
    if {$clone_kick == "1"} {
        if {![matchattr $handle o]} {
            foreach i [chanlist $channel] {
                if {[string tolower [lindex [split $uhost @] 1]] == [string tolower [lindex [split [getchanhost $i $channel] @] 1]] && $i != $nick && ![matchattr [nick2hand $i $channel] o]} {set clone 1}
            }
            if $clone {
                newchanban $channel *!*@[lindex [split [maskhost $uhost] @] 1] $handle "You will be unbanned for CLONING in 3 minutes." 3
            }
        }
    }
    return 0
}

####### VOTE #######
if ![info exists kewl_vote] {set kewl_vote ""}
if ![info exists kewl_vote2] {set kewl_vote2 "0 0"}
bind msg m vote msg_do_votes
proc msg_do_votes {nick uhost handle vars} {
    global botnick kewl_vote botnick kewl_vote2
    set who [lindex $vars 0]
    if {$who == ""} {
        puthelp "NOTICE $nick :USAGE: /msg $botnick vote <user>"
        return 0
    }
    if {$kewl_vote != "" && $who != "end"} {
        puthelp "NOTICE $nick :$kewl_vote is already being voted for! '/msg $botnick vote end' to close the polls and see the results."
        return 0
    }
    if {$kewl_vote != "" && $who == "end"} {
        set yes [lindex $kewl_vote2 0]
        set no [lindex $kewl_vote2 1]
        puthelp "NOTICE $nick :Poll results:"
        puthelp "NOTICE $nick :YES: $yes"
        puthelp "NOTICE $nick : NO: $no"
        if {$yes > $no} then {puthelp "NOTICE $nick :$kewl_vote has been voted in!"}
        if {$yes < $no} then {puthelp "NOTICE $nick :$kewl_vote has been voted OUT!"}
        if {$yes == $no} then {puthelp "NOTICE $nick :It's a tie! $yes-$no! Re-Vote!"}
        set kewl_vote ""
        set kewl_vote2 ""
        set kewl_vote3 ""
        return 1
    }   
    if {![validuser $who]} {
        puthelp "NOTICE $nick :$who isn't a valid user!"
        return 0
    }
    set kewl_vote $who
    foreach j [chanlist [lindex [channels] o] {
        puthelp "NOTICE $j :Voting for $who.."
        puthelp "NOTICE $j :/msg $botnick vote <y/n>"
    }
    puthelp "NOTICE $nick :'/msg $botnick vote end' to close the polls"
    return 1
}
if ![info exists kewl_vote3] {set kewl_vote3 ""}
bind msg o vote msg_do_vote
proc msg_do_vote {nick uhost handle vars} {
    global kewl_vote kewl_vote2 kewl_vote3
    set yn [string tolower [lindex $vars 0]]
    if {$yn != "y" && $yn != "y"} {
        puthelp "NOTICE $nick :Y or N please.."
        return 0
    }
    if {[string match "* $handle *" $kewl_vote3]} {
        puthelp "NOTICE $nick :You already voted!"
        return 0
    }
    if {$yn == "y"} {
        set kewl_vote2 "[expr [lindex $kewl_vote2 0] + 1] [lindex $kewl_vote2 1]"
        append $kewl_vote3 " $handle "
        puthelp "NOTICE $nick :Voted for $kewl_vote to be in.."
        return 1
    }
    if {$yn == "n"} {
        set kewl_vote2 "[lindex $kewl_vote2 0] [expr [lindex $kewl_vote2 1] + 1]"
        append $kewl_vote3 " $handle "
        return 1
    }
    return 0
}

bind pubm - * pubm_dont_talk2me
proc pubm_dont_talk2me {niq uhost handle channel vars} {
    global nick anti_nick
    if {[string match *[string tolower $nick]* [string tolower $vars]] && $anti_nick == "1"} {
        puthelp "PRIVMSG $channel :don't talk to me"
    }
    return 0
}
bind pubm - "*\\?" pub_8ball
proc pub_8ball {nick uhost handle channel vars} {
    global 8ball 8ball_say
    if {$8ball != "0"} {
        if {[rand $8ball] == "0"} {
            puthelp "PRIVMSG $channel :$nick: [lindex $8ball_say [rand [llength $8ball_say]]]"
        }
    }
}

#---------#---------#---------#---------#---------#---------#---------#-------#

putlog "kool, jew loaded da king of all scripti0z"
